# Base git commit: c4238686f909
# (ARM: 9381/1: kasan: clear stale stack poison)
# 
# Author:    Russell King (Oracle) (Wed 15 May 21:41:54 BST 2024)
# Committer: Russell King (Oracle) (Wed 15 May 21:41:54 BST 2024)
# 
#   Merge branches 'amba', 'cfi', 'clkdev', 'fixes' and 'misc' into for-next
# 
# Author:    Geert Uytterhoeven (Wed 15 May 15:03:35 BST 2024)
# Committer: Russell King (Oracle) (Wed 15 May 21:41:08 BST 2024)
# 
#   ARM: 9398/1: Fix userspace enter on LPAE with CC_OPTIMIZE_FOR_SIZE=y
# 
#   Booting an LPAE-enabled kernel built with CONFIG_CC_OPTIMIZE_FOR_SIZE=y
#   fails when starting userspace:
# 
#       Kernel panic - not syncing: Attempted to kill init! exitcode=0x00000004
#       CPU: 1 PID: 1 Comm: init Tainted: G        W        N 6.9.0-rc1-koelsch-00004-g7af5b901e847 #1930
#       Hardware name: Generic R-Car Gen2 (Flattened Device Tree)
#       Call trace:
#        unwind_backtrace from show_stack+0x10/0x14
#        show_stack from dump_stack_lvl+0x78/0xa8
#        dump_stack_lvl from panic+0x118/0x398
#        panic from do_exit+0x1ec/0x938
#        do_exit from sys_exit_group+0x0/0x10
#       ---[ end Kernel panic - not syncing: Attempted to kill init!  exitcode=0x00000004 ]---
# 
#   Add the missing memory clobber to cpu_set_ttbcr(), as suggested by
#   Russell King.
# 
#   Force inlining of uaccess_save_and_enable(), as suggested by Ard
#   Biesheuvel.
# 
#   The latter fixes booting on Koelsch.
# 
#   Closes: https://lore.kernel.org/r/CAMuHMdWTAJcZ9BReWNhpmsgkOzQxLNb5OhNYxzxv6D5TSh2fwQ@mail.gmail.com/
# 
#   Fixes: 7af5b901e84743c6 ("ARM: 9358/2: Implement PAN for LPAE by TTBR0 page table walks disablement")
#   Acked-by: Ard Biesheuvel
#   Reviewed-by: Linus Walleij
#   Tested-by: Florian Fainelli
#   Signed-off-by: Geert Uytterhoeven
#   Signed-off-by: Russell King (Oracle)
# 
#   eebadafc3b14d9426fa9cc3ab0da0e48367c7114
#    arch/arm/include/asm/proc-fns.h | 2 +-
#    arch/arm/include/asm/uaccess.h  | 2 +-
#    2 files changed, 2 insertions(+), 2 deletions(-)
# 
# Author:    Russell King (Oracle) (Fri 15 Mar 11:45:11 GMT 2024)
# Committer: Russell King (Oracle) (Wed  8 May 16:26:30 BST 2024)
# 
#   clkdev: report over-sized strings when creating clkdev entries
# 
#   Report an error when an attempt to register a clkdev entry results in a
#   truncated string so the problem can be easily spotted.
# 
#   Reported by: Duanqiang Wen
#   Signed-off-by: Russell King (Oracle)
# 
#   8d532528ff6a6b1bccf648d0f5713188e292ce8f
#    drivers/clk/clkdev.c | 35 +++++++++++++++++++++++++++++++++--
#    1 file changed, 33 insertions(+), 2 deletions(-)
# 
# Author:    Linus Walleij (Thu  2 May 08:13:24 BST 2024)
# Committer: Russell King (Oracle) (Tue  7 May 10:30:24 BST 2024)
# 
#   ARM: 9393/1: mm: Use conditionals for CFI branches
# 
#   Commit 9385/2 introduced a few branches inside function
#   prototypes when using CFI in order to deal with the situation
#   where CFI inserts a few bytes of function information in front
#   of the symbol.
# 
#   This is not good for older CPUs where every cycle counts.
# 
#   Commit 9386/2 alleviated the situation a bit by using aliases
#   for the cache functions with identical signatures.
# 
#   This leaves the coherent cache flush functions
#   *_coherent_kern_range() with these branches to the corresponing
#   *_coherent_user_range() around, since their return type differ and
#   they therefore cannot be aliased.
# 
#   Solve this by a simple ifdef so at least we can use fallthroughs
#   when compiling without CFI enabled.
# 
#   Link: https://lore.kernel.org/linux-arm-kernel/Zi+e9M%2Ff5b%2FSto9H@shell.armlinux.org.uk/
# 
#   Suggested-by: Ard Biesheuvel
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   7b749aad1faa5bcb23b45b7126f677ab17324c40
#    arch/arm/mm/cache-fa.S      | 2 ++
#    arch/arm/mm/cache-v4.S      | 2 ++
#    arch/arm/mm/cache-v4wb.S    | 4 ++++
#    arch/arm/mm/cache-v4wt.S    | 2 ++
#    arch/arm/mm/cache-v6.S      | 2 ++
#    arch/arm/mm/cache-v7.S      | 2 ++
#    arch/arm/mm/cache-v7m.S     | 2 ++
#    arch/arm/mm/proc-arm1020.S  | 2 ++
#    arch/arm/mm/proc-arm1020e.S | 2 ++
#    arch/arm/mm/proc-arm1022.S  | 2 ++
#    arch/arm/mm/proc-arm1026.S  | 2 ++
#    arch/arm/mm/proc-arm920.S   | 2 ++
#    arch/arm/mm/proc-arm922.S   | 2 ++
#    arch/arm/mm/proc-arm925.S   | 2 ++
#    arch/arm/mm/proc-arm926.S   | 2 ++
#    arch/arm/mm/proc-arm940.S   | 2 ++
#    arch/arm/mm/proc-arm946.S   | 2 ++
#    arch/arm/mm/proc-feroceon.S | 2 ++
#    arch/arm/mm/proc-mohawk.S   | 2 ++
#    arch/arm/mm/proc-xsc3.S     | 2 ++
#    20 files changed, 42 insertions(+)
# 
# Author:    Linus Walleij (Tue 23 Apr 08:54:45 BST 2024)
# Committer: Russell King (Oracle) (Mon 29 Apr 14:14:23 BST 2024)
# 
#   ARM: 9392/2: Support CLANG CFI
# 
#   Support Control Flow Integrity (CFI) when compiling with
#   CLANG.
# 
#   In the as-of-writing LLVM CLANG implementation (v17)
#   the 32-bit ARM platform is supported by the generic CFI
#   implementation, which isn't tailored specifically for ARM32
#   but works well enough to enable the feature.
# 
#   Tested-by: Kees Cook
#   Reviewed-by: Sami Tolvanen
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   1a4fec49efe5273eb2fcf575175a117745f76f97
#    arch/arm/Kconfig | 1 +
#    1 file changed, 1 insertion(+)
# 
# Author:    Linus Walleij (Tue 23 Apr 08:53:09 BST 2024)
# Committer: Russell King (Oracle) (Mon 29 Apr 14:14:22 BST 2024)
# 
#   ARM: 9391/2: hw_breakpoint: Handle CFI breakpoints
# 
#   This registers a breakpoint handler for the new breakpoint type
#   (0x03) inserted by LLVM CLANG for CFI breakpoints.
# 
#   If we are in permissive mode, just print a backtrace and continue.
# 
#   Example with CONFIG_CFI_PERMISSIVE enabled:
# 
#   > echo CFI_FORWARD_PROTO > /sys/kernel/debug/provoke-crash/DIRECT
#   lkdtm: Performing direct entry CFI_FORWARD_PROTO
#   lkdtm: Calling matched prototype ...
#   lkdtm: Calling mismatched prototype ...
#   CFI failure at lkdtm_indirect_call+0x40/0x4c (target: 0x0; expected type: 0x00000000)
#   WARNING: CPU: 1 PID: 112 at lkdtm_indirect_call+0x40/0x4c
#   CPU: 1 PID: 112 Comm: sh Not tainted 6.8.0-rc1+ #150
#   Hardware name: ARM-Versatile Express
#   (...)
#   lkdtm: FAIL: survived mismatched prototype function call!
#   lkdtm: Unexpected! This kernel (6.8.0-rc1+ armv7l) was built with CONFIG_CFI_CLANG=y
# 
#   As you can see the LKDTM test fails, but I expect that this would be
#   expected behaviour in the permissive mode.
# 
#   We are currently not implementing target and type for the CFI
#   breakpoint as this requires additional operand bundling compiler
#   extensions.
# 
#   CPUs without breakpoint support cannot handle breakpoints naturally,
#   in these cases the permissive mode will not work, CFI will fall over
#   on an undefined instruction:
# 
#   Internal error: Oops - undefined instruction: 0 [#1] PREEMPT ARM
#   CPU: 0 PID: 186 Comm: ash Tainted: G        W          6.9.0-rc1+ #7
#   Hardware name: Gemini (Device Tree)
#   PC is at lkdtm_indirect_call+0x38/0x4c
#   LR is at lkdtm_CFI_FORWARD_PROTO+0x30/0x6c
# 
#   This is reasonable I think: it's the best CFI can do to ascertain
#   the the control flow is not broken on these CPUs.
# 
#   Reviewed-by: Kees Cook
#   Tested-by: Kees Cook
#   Reviewed-by: Sami Tolvanen
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   c3f89986fde7bb9ccc86a901bf28e1f7d69fc3b3
#    arch/arm/include/asm/hw_breakpoint.h |  1 +
#    arch/arm/kernel/hw_breakpoint.c      | 35 +++++++++++++++++++++++++++++++++++
#    2 files changed, 36 insertions(+)
# 
# Author:    Linus Walleij (Tue 23 Apr 08:50:38 BST 2024)
# Committer: Russell King (Oracle) (Mon 29 Apr 14:14:21 BST 2024)
# 
#   ARM: 9390/2: lib: Annotate loop delay instructions for CFI
# 
#   When we annotate the loop delay code with SYM_TYPED_FUNC_START()
#   a function prototype signature will be emitted into the object
#   file above each site called from C, and the delay loop code is
#   using "fallthroughs" from the different assembly callbacks. This
#   will not work as the execution flow will run into the prototype
#   signatures.
# 
#   Rewrite the code to use explicit branches to the other code
#   segments and annotate the code using SYM_TYPED_FUNC_START().
# 
#   Tested on the ARM Versatile which uses the calibrated loop delay.
# 
#   Tested-by: Kees Cook
#   Reviewed-by: Sami Tolvanen
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   7339fb11aea8387d1ceb260323a2c87faa48fdcd
#    arch/arm/lib/delay-loop.S | 16 ++++++++++------
#    1 file changed, 10 insertions(+), 6 deletions(-)
# 
# Author:    Linus Walleij (Tue 23 Apr 08:48:42 BST 2024)
# Committer: Russell King (Oracle) (Mon 29 Apr 14:14:20 BST 2024)
# 
#   ARM: 9389/2: mm: Define prototypes for all per-processor calls
# 
#   Each CPU type ("proc") has assembly calls for initializing and
#   setting up the MM context, idle and so forth.
# 
#   These calls have the C form of e.g.:
# 
#   void cpu_arm920_init(void);
# 
#   However this prototype is not really specified, instead it is
#   generated by the glue code in <asm/glue-proc.h> and the prototype
#   is implicit from the generic prototype defined in <asm/proc-fns.h>
#   such as cpu_proc_init() in this case. (This is a bit similar to
#   the "interface" or inheritance concept in other languages.)
# 
#   To be able to annotate these assembly calls for CFI, they all need
#   to have a proper C prototype per CPU call.
# 
#   Define these in a new C file that is only compiled when we use
#   CFI, and add __ADDRESSABLE() to each so the compiler knows that
#   these will be addressed (they are not explicitly called in C, they
#   are called by way of cpu_proc_init() etc).
# 
#   It is a bit of definitions, but we do not expect new ARM32 CPUs
#   to appear very much so it should be pretty static.
# 
#   Tested-by: Kees Cook
#   Reviewed-by: Sami Tolvanen
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   393999fa96273bab8d6efb2f4724030916afd61b
#    arch/arm/mm/Makefile |   1 +
#    arch/arm/mm/proc.c   | 500 +++++++++++++++++++++++++++++++++++++++++++++++++++
#    2 files changed, 501 insertions(+)
#    create mode 100644 arch/arm/mm/proc.c
# 
# Author:    Linus Walleij (Tue 23 Apr 08:45:47 BST 2024)
# Committer: Russell King (Oracle) (Mon 29 Apr 14:14:19 BST 2024)
# 
#   ARM: 9388/2: mm: Type-annotate all per-processor assembly routines
# 
#   Type tag the remaining per-processor assembly using the CFI
#   symbol macros, in addition to those that were previously tagged
#   for cache maintenance calls.
# 
#   This will be used to finally provide proper C prototypes for
#   all these calls as well so that CFI can be made to work.
# 
#   Tested-by: Kees Cook
#   Acked-by: Arnd Bergmann
#   Reviewed-by: Sami Tolvanen
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   51db13aa8d09ecd33ff712d888a8cfe5ac89d6de
#    arch/arm/mm/proc-arm1020.S   | 24 ++++++++++------
#    arch/arm/mm/proc-arm1020e.S  | 24 ++++++++++------
#    arch/arm/mm/proc-arm1022.S   | 24 ++++++++++------
#    arch/arm/mm/proc-arm1026.S   | 24 ++++++++++------
#    arch/arm/mm/proc-arm720.S    | 25 +++++++++++------
#    arch/arm/mm/proc-arm740.S    | 26 ++++++++++++-----
#    arch/arm/mm/proc-arm7tdmi.S  | 34 +++++++++++++++--------
#    arch/arm/mm/proc-arm920.S    | 31 ++++++++++++---------
#    arch/arm/mm/proc-arm922.S    | 23 +++++++++------
#    arch/arm/mm/proc-arm925.S    | 22 +++++++++------
#    arch/arm/mm/proc-arm926.S    | 31 +++++++++++++--------
#    arch/arm/mm/proc-arm940.S    | 21 +++++++++-----
#    arch/arm/mm/proc-arm946.S    | 21 +++++++++-----
#    arch/arm/mm/proc-arm9tdmi.S  | 26 ++++++++++++-----
#    arch/arm/mm/proc-fa526.S     | 24 ++++++++++------
#    arch/arm/mm/proc-feroceon.S  | 30 ++++++++++++--------
#    arch/arm/mm/proc-mohawk.S    | 30 ++++++++++++--------
#    arch/arm/mm/proc-sa110.S     | 23 +++++++++------
#    arch/arm/mm/proc-sa1100.S    | 31 +++++++++++++--------
#    arch/arm/mm/proc-v6.S        | 31 +++++++++++++--------
#    arch/arm/mm/proc-v7-2level.S |  8 +++---
#    arch/arm/mm/proc-v7-3level.S |  8 +++---
#    arch/arm/mm/proc-v7.S        | 66 +++++++++++++++++++++++---------------------
#    arch/arm/mm/proc-v7m.S       | 41 +++++++++++++--------------
#    arch/arm/mm/proc-xsc3.S      | 30 ++++++++++++--------
#    arch/arm/mm/proc-xscale.S    | 30 ++++++++++++--------
#    26 files changed, 434 insertions(+), 274 deletions(-)
# 
# Author:    Linus Walleij (Tue 23 Apr 08:43:14 BST 2024)
# Committer: Russell King (Oracle) (Mon 29 Apr 14:14:18 BST 2024)
# 
#   ARM: 9387/2: mm: Rewrite cacheflush vtables in CFI safe C
# 
#   Instead of defining all cache flush operations with an assembly
#   macro in proc-macros.S, provide an explicit struct cpu_cache_fns
#   for each CPU cache type in mm/cache.c.
# 
#   As a side effect from rewriting the vtables in C, we can
#   avoid the aliasing for the "louis" cache callback, instead we
#   can just assign the NN_flush_kern_cache_all() function to the
#   louis callback in the C vtable.
# 
#   As the louis cache callback is called explicitly (not through the
#   vtable) if we only have one type of cache support compiled in, we
#   need an ifdef quirk for this in the !MULTI_CACHE case.
# 
#   Feroceon and XScale have some dma mapping quirk, in this case we
#   can just define two structs and assign all but one callback to the
#   main implementation; since each of them invoked define_cache_functions
#   twice they require MULTI_CACHE by definition so the compiled-in
#   shortcut is not used on these variants.
# 
#   Tested-by: Kees Cook
#   Reviewed-by: Sami Tolvanen
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   b4d20eff64d5912b95d7a397057aba9c8e9c9a8a
#    arch/arm/include/asm/glue-cache.h |  28 +-
#    arch/arm/mm/Makefile              |   1 +
#    arch/arm/mm/cache-b15-rac.c       |   1 +
#    arch/arm/mm/cache-fa.S            |   8 -
#    arch/arm/mm/cache-nop.S           |   8 -
#    arch/arm/mm/cache-v4.S            |   8 -
#    arch/arm/mm/cache-v4wb.S          |   8 -
#    arch/arm/mm/cache-v4wt.S          |   8 -
#    arch/arm/mm/cache-v6.S            |   8 -
#    arch/arm/mm/cache-v7.S            |  25 --
#    arch/arm/mm/cache-v7m.S           |   8 -
#    arch/arm/mm/cache.c               | 663 ++++++++++++++++++++++++++++++++++++++
#    arch/arm/mm/proc-arm1020.S        |   6 -
#    arch/arm/mm/proc-arm1020e.S       |   6 -
#    arch/arm/mm/proc-arm1022.S        |   6 -
#    arch/arm/mm/proc-arm1026.S        |   6 -
#    arch/arm/mm/proc-arm920.S         |   5 -
#    arch/arm/mm/proc-arm922.S         |   6 -
#    arch/arm/mm/proc-arm925.S         |   6 -
#    arch/arm/mm/proc-arm926.S         |   6 -
#    arch/arm/mm/proc-arm940.S         |   6 -
#    arch/arm/mm/proc-arm946.S         |   6 -
#    arch/arm/mm/proc-feroceon.S       |  27 --
#    arch/arm/mm/proc-macros.S         |  18 --
#    arch/arm/mm/proc-mohawk.S         |   6 -
#    arch/arm/mm/proc-xsc3.S           |   6 -
#    arch/arm/mm/proc-xscale.S         |  57 +---
#    27 files changed, 688 insertions(+), 259 deletions(-)
#    create mode 100644 arch/arm/mm/cache.c
# 
# Author:    Linus Walleij (Tue 23 Apr 08:31:41 BST 2024)
# Committer: Russell King (Oracle) (Mon 29 Apr 14:14:17 BST 2024)
# 
#   ARM: 9386/2: mm: Use symbol alias for cache functions
# 
#   The cache functions to flush user cache (*_flush_user_cache_all)
#   are in many cases just a branch to the corresponfing userspace or
#   kernelspace function. These functions also have the same arguments.
# 
#   Simplify these by using SYM_FUNC_ALIAS() in all affected sites.
# 
#   The NOP cache has very many similar calls which are just returns,
#   but it would be confusing to use aliases here, so leave all the
#   explicit returns and drop a comment on why we are not using aliases.
# 
#   Reviewed-by: Sami Tolvanen
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   2074beebacfc09b6c47dce1f573a67131c70ec9a
#    arch/arm/mm/cache-fa.S      | 4 +---
#    arch/arm/mm/cache-nop.S     | 4 ++++
#    arch/arm/mm/cache-v4.S      | 4 +---
#    arch/arm/mm/cache-v4wb.S    | 4 +---
#    arch/arm/mm/cache-v4wt.S    | 4 +---
#    arch/arm/mm/proc-arm1020.S  | 4 +---
#    arch/arm/mm/proc-arm1020e.S | 4 +---
#    arch/arm/mm/proc-arm1022.S  | 4 +---
#    arch/arm/mm/proc-arm1026.S  | 4 +---
#    arch/arm/mm/proc-arm920.S   | 4 +---
#    arch/arm/mm/proc-arm922.S   | 4 +---
#    arch/arm/mm/proc-arm925.S   | 4 +---
#    arch/arm/mm/proc-arm926.S   | 4 +---
#    arch/arm/mm/proc-arm940.S   | 4 +---
#    arch/arm/mm/proc-arm946.S   | 4 +---
#    arch/arm/mm/proc-feroceon.S | 4 +---
#    arch/arm/mm/proc-mohawk.S   | 4 +---
#    arch/arm/mm/proc-xsc3.S     | 4 +---
#    arch/arm/mm/proc-xscale.S   | 4 +---
#    19 files changed, 22 insertions(+), 54 deletions(-)
# 
# Author:    Linus Walleij (Tue 23 Apr 08:29:31 BST 2024)
# Committer: Russell King (Oracle) (Mon 29 Apr 14:14:16 BST 2024)
# 
#   ARM: 9385/2: mm: Type-annotate all cache assembly routines
# 
#   Tag all references to assembly functions with SYM_TYPED_FUNC_START()
#   and SYM_FUNC_END() so they also become CFI-safe.
# 
#   When we add SYM_TYPED_FUNC_START() to assembly calls, a function
#   prototype signature will be emitted into the object file at
#   (pc-4) at the call site, so that the KCFI runtime check can compare
#   this to the expected call. Example:
# 
#   8011ae38:       a540670c        .word   0xa540670c
# 
#   8011ae3c <v7_flush_icache_all>:
#   8011ae3c:       e3a00000        mov     r0, #0
#   8011ae40:       ee070f11        mcr     15, 0, r0, cr7, cr1, {0}
#   8011ae44:       e12fff1e        bx      lr
# 
#   This means no "fallthrough" code can enter a SYM_TYPED_FUNC_START()
#   call from above it: there will be a function prototype signature
#   there, so those are consistently converted to a branch or ret lr
#   depending on context.
# 
#   Tested-by: Kees Cook
#   Reviewed-by: Sami Tolvanen
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   1036b89580dc611cfb5dfe66af6b35452dfb272c
#    arch/arm/mm/cache-fa.S      | 39 +++++++++++++++++++++-------------
#    arch/arm/mm/cache-nop.S     | 51 ++++++++++++++++++++++++++-------------------
#    arch/arm/mm/cache-v4.S      | 47 ++++++++++++++++++++++++-----------------
#    arch/arm/mm/cache-v4wb.S    | 39 ++++++++++++++++++++--------------
#    arch/arm/mm/cache-v4wt.S    | 47 ++++++++++++++++++++++++-----------------
#    arch/arm/mm/cache-v6.S      | 41 ++++++++++++++++++++----------------
#    arch/arm/mm/cache-v7.S      | 49 ++++++++++++++++++++++---------------------
#    arch/arm/mm/cache-v7m.S     | 45 ++++++++++++++++++++-------------------
#    arch/arm/mm/proc-arm1020.S  | 39 +++++++++++++++++++++-------------
#    arch/arm/mm/proc-arm1020e.S | 40 ++++++++++++++++++++++-------------
#    arch/arm/mm/proc-arm1022.S  | 39 +++++++++++++++++++++-------------
#    arch/arm/mm/proc-arm1026.S  | 40 ++++++++++++++++++++++-------------
#    arch/arm/mm/proc-arm920.S   | 40 +++++++++++++++++++++--------------
#    arch/arm/mm/proc-arm922.S   | 40 +++++++++++++++++++++--------------
#    arch/arm/mm/proc-arm925.S   | 38 ++++++++++++++++++++-------------
#    arch/arm/mm/proc-arm926.S   | 38 ++++++++++++++++++++-------------
#    arch/arm/mm/proc-arm940.S   | 42 ++++++++++++++++++++++---------------
#    arch/arm/mm/proc-arm946.S   | 38 ++++++++++++++++++++-------------
#    arch/arm/mm/proc-feroceon.S | 48 +++++++++++++++++++++++++-----------------
#    arch/arm/mm/proc-mohawk.S   | 38 ++++++++++++++++++++-------------
#    arch/arm/mm/proc-xsc3.S     | 39 +++++++++++++++++++++-------------
#    arch/arm/mm/proc-xscale.S   | 40 +++++++++++++++++++++--------------
#    22 files changed, 544 insertions(+), 373 deletions(-)
# 
# Author:    Ard Biesheuvel (Tue 23 Apr 08:25:41 BST 2024)
# Committer: Russell King (Oracle) (Mon 29 Apr 14:14:15 BST 2024)
# 
#   ARM: 9384/2: mm: Make tlbflush routines CFI safe
# 
#   Instead of avoiding CFI entirely on the TLB flush helpers, reorganize
#   the code so that the CFI machinery can deal with it. The important
#   things to take into account are:
#   - functions in asm called indirectly from C need to be defined using
#     SYM_TYPED_FUNC_START()
#   - a reference to the asm function needs to be visible to the compiler,
#     in order to get it to emit the typeid symbol.
# 
#   The latter means that defining the cpu_tlb_fns structs is best done from
#   C code, so that the references in the static initializers will be
#   visible to the compiler.
# 
#   Signed-off-by: Ard Biesheuvel
#   Tested-by: Kees Cook
#   Reviewed-by: Sami Tolvanen
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   6b0ef2792c223636a86f2c9c3fcb26502a03d5a7
#    arch/arm/mm/Makefile      |  1 +
#    arch/arm/mm/proc-macros.S | 15 ---------
#    arch/arm/mm/tlb-fa.S      | 12 +++----
#    arch/arm/mm/tlb-v4.S      | 15 +++++----
#    arch/arm/mm/tlb-v4wb.S    | 12 +++----
#    arch/arm/mm/tlb-v4wbi.S   | 12 +++----
#    arch/arm/mm/tlb-v6.S      | 12 +++----
#    arch/arm/mm/tlb-v7.S      | 14 +++-----
#    arch/arm/mm/tlb.c         | 84 +++++++++++++++++++++++++++++++++++++++++++++++
#    9 files changed, 119 insertions(+), 58 deletions(-)
#    create mode 100644 arch/arm/mm/tlb.c
# 
# Author:    Linus Walleij (Mon 15 Apr 09:42:42 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:12:18 BST 2024)
# 
#   ARM: 9382/1: ftrace: Define ftrace_stub_graph
# 
#   Several architectures defines this stub for the graph tracer,
#   and it is needed for CFI, as it needs a separate symbol for it.
#   The trick from include/asm-generic/vmlinux.lds.h to define
#   ftrace_stub_graph to ftrace_stub isn't working when using CFI.
#   Commit 883bbbffa5a4 contains the details.
# 
#   Tested-by: Kees Cook
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   a9a058031cfb7e1fcd7a03a4f7228179a0426cb4
#    arch/arm/kernel/entry-ftrace.S | 4 ++++
#    1 file changed, 4 insertions(+)
# 
# Author:    Linus Walleij (Mon 25 Mar 07:31:13 GMT 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:10:46 BST 2024)
# 
#   ARM: 9358/2: Implement PAN for LPAE by TTBR0 page table walks disablement
# 
#   With LPAE enabled, privileged no-access cannot be enforced using CPU
#   domains as such feature is not available. This patch implements PAN
#   by disabling TTBR0 page table walks while in kernel mode.
# 
#   The ARM architecture allows page table walks to be split between TTBR0
#   and TTBR1. With LPAE enabled, the split is defined by a combination of
#   TTBCR T0SZ and T1SZ bits. Currently, an LPAE-enabled kernel uses TTBR0
#   for user addresses and TTBR1 for kernel addresses with the VMSPLIT_2G
#   and VMSPLIT_3G configurations. The main advantage for the 3:1 split is
#   that TTBR1 is reduced to 2 levels, so potentially faster TLB refill
#   (though usually the first level entries are already cached in the TLB).
# 
#   The PAN support on LPAE-enabled kernels uses TTBR0 when running in user
#   space or in kernel space during user access routines (TTBCR T0SZ and
#   T1SZ are both 0). When running user accesses are disabled in kernel
#   mode, TTBR0 page table walks are disabled by setting TTBCR.EPD0. TTBR1
#   is used for kernel accesses (including loadable modules; anything
#   covered by swapper_pg_dir) by reducing the TTBCR.T0SZ to the minimum
#   (2^(32-7) = 32MB). To avoid user accesses potentially hitting stale TLB
#   entries, the ASID is switched to 0 (reserved) by setting TTBCR.A1 and
#   using the ASID value in TTBR1. The difference from a non-PAN kernel is
#   that with the 3:1 memory split, TTBR1 always uses 3 levels of page
#   tables.
# 
#   As part of the change we are using preprocessor elif definied() clauses
#   so balance these clauses by converting relevant precedingt ifdef
#   clauses to if defined() clauses.
# 
#   Signed-off-by: Catalin Marinas
#   Reviewed-by: Kees Cook
#   Tested-by: Florian Fainelli
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   7af5b901e84743c608aae90cb0e429702812c324
#    arch/arm/Kconfig                            | 22 +++++++++++++--
#    arch/arm/include/asm/assembler.h            |  1 +
#    arch/arm/include/asm/pgtable-3level-hwdef.h |  9 ++++++
#    arch/arm/include/asm/ptrace.h               |  1 +
#    arch/arm/include/asm/uaccess-asm.h          | 44 ++++++++++++++++++++++++++++-
#    arch/arm/include/asm/uaccess.h              | 26 ++++++++++++++++-
#    arch/arm/kernel/asm-offsets.c               |  1 +
#    arch/arm/kernel/suspend.c                   |  8 ++++++
#    arch/arm/lib/csumpartialcopyuser.S          | 20 ++++++++++++-
#    arch/arm/mm/fault.c                         | 29 +++++++++++++++++++
#    10 files changed, 155 insertions(+), 6 deletions(-)
# 
# Author:    Linus Walleij (Mon 25 Mar 07:30:02 GMT 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:10:45 BST 2024)
# 
#   ARM: 9357/2: Reduce the number of #ifdef CONFIG_CPU_SW_DOMAIN_PAN
# 
#   This is a clean-up patch aimed at reducing the number of checks on
#   CONFIG_CPU_SW_DOMAIN_PAN, together with some empty lines for better
#   clarity once the CONFIG_CPU_TTBR0_PAN is introduced.
# 
#   Signed-off-by: Catalin Marinas
#   Reviewed-by: Kees Cook
#   Tested-by: Florian Fainelli
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   de7f60f0b03175ff056f18996d7e2577bc4baa65
#    arch/arm/include/asm/uaccess-asm.h | 16 ++++++++++++----
#    arch/arm/include/asm/uaccess.h     | 21 +++++++++++++++------
#    2 files changed, 27 insertions(+), 10 deletions(-)
# 
# Author:    Linus Walleij (Mon 25 Mar 07:28:50 GMT 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:10:44 BST 2024)
# 
#   ARM: 9356/2: Move asm statements accessing TTBCR into C functions
# 
#   This patch implements cpu_get_ttbcr() and cpu_set_ttbcr() and replaces
#   the corresponding asm statements.
# 
#   Signed-off-by: Catalin Marinas
#   Reviewed-by: Kees Cook
#   Tested-by: Florian Fainelli
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   66abdd3b5d4e53bc17c524493b404266e0af114e
#    arch/arm/include/asm/proc-fns.h | 12 ++++++++++++
#    arch/arm/mm/mmu.c               |  7 +++----
#    2 files changed, 15 insertions(+), 4 deletions(-)
# 
# Author:    Linus Walleij (Mon 25 Mar 07:27:00 GMT 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:10:43 BST 2024)
# 
#   ARM: 9355/2: Add TTBCR_* definitions to pgtable-3level-hwdef.h
# 
#   These macros will be used in a subsequent patch.
# 
#   At one point these were part of the ARM32 KVM but that is no
#   longer the case.
# 
#   Since these macros are only relevant to LPAE kernel builds, they
#   are added to pgtable-3level-hwdef.h
# 
#   Signed-off-by: Catalin Marinas
#   Reviewed-by: Kees Cook
#   Tested-by: Florian Fainelli
#   Signed-off-by: Linus Walleij
#   Signed-off-by: Russell King (Oracle)
# 
#   a8f15b31a6479d077b851c86a2cc47391bccafb5
#    arch/arm/include/asm/pgtable-3level-hwdef.h | 17 +++++++++++++++++
#    1 file changed, 17 insertions(+)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:18 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:28 BST 2024)
# 
#   ARM: 9379/1: coresight: tpda: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-11-4517b091385b@linaro.org
# 
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   aff00427579d4c915ee92553f712e4c632185e6e
#    drivers/hwtracing/coresight/coresight-tpda.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:12 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:27 BST 2024)
# 
#   ARM: 9378/1: coresight: etm4x: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-5-4517b091385b@linaro.org
# 
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   8fea6b7ff574dd4e04364de8c2cdfc2f2b7d47c2
#    drivers/hwtracing/coresight/coresight-etm4x-core.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:22 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:26 BST 2024)
# 
#   ARM: 9377/1: hwrng: nomadik: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-15-4517b091385b@linaro.org
# 
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   4b5bcd5a3c843fb72ee5c25dcf28338905f295bd
#    drivers/char/hw_random/nomadik-rng.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:19 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:25 BST 2024)
# 
#   ARM: 9376/1: coresight: tpdm: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-12-4517b091385b@linaro.org
# 
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   87ef18443e24cac1aaa78ffcf16fce991ed246da
#    drivers/hwtracing/coresight/coresight-tpdm.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:16 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:25 BST 2024)
# 
#   ARM: 9375/1: coresight: stm: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-9-4517b091385b@linaro.org
# 
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   60bf16d824fb5623e5a721ae7d458048b4bcbd0f
#    drivers/hwtracing/coresight/coresight-stm.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:15 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:24 BST 2024)
# 
#   ARM: 9374/1: coresight: etb10: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-8-4517b091385b@linaro.org
# 
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   a0c50b9bd932139e7f2bc7e8851a446e5e8a4392
#    drivers/hwtracing/coresight/coresight-etb10.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:13 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:23 BST 2024)
# 
#   ARM: 9373/1: coresight: funnel: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-6-4517b091385b@linaro.org
# 
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   7ebc2eefdc3c4a913df05fedf784bd0a81daf1cb
#    drivers/hwtracing/coresight/coresight-funnel.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:25 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:22 BST 2024)
# 
#   ARM: 9372/1: memory: pl353-smc: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-18-4517b091385b@linaro.org
# 
#   Reviewed-by: Miquel Raynal
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   93fcceffc6a6fe261ccd5f1565e0b8d5f176f41a
#    drivers/memory/pl353-smc.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:09 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:22 BST 2024)
# 
#   ARM: 9371/1: coresight: cti: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-2-4517b091385b@linaro.org
# 
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   862acebd11861996dc90a45caacb4b95332841de
#    drivers/hwtracing/coresight/coresight-cti-core.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:26 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:21 BST 2024)
# 
#   ARM: 9370/1: vfio: amba: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-19-4517b091385b@linaro.org
# 
#   Reviewed-by: Eric Auger
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   bb549ce39d3f8eb60e87c32a41b3fadf4b15954e
#    drivers/vfio/platform/vfio_amba.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:24 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:20 BST 2024)
# 
#   ARM: 9369/1: Input: ambakmi - drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-17-4517b091385b@linaro.org
# 
#   Acked-by: Dmitry Torokhov
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   6fce490c80cf2382d6ffe5d653c98d06db041b6c
#    drivers/input/serio/ambakmi.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:23 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:19 BST 2024)
# 
#   ARM: 9368/1: dmaengine: pl330: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-16-4517b091385b@linaro.org
# 
#   Acked-by: Vinod Koul
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   8ab268e97d06e0be4339b6a8d9eccfae959587a8
#    drivers/dma/pl330.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:21 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:18 BST 2024)
# 
#   ARM: 9367/1: i2c: nomadik: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-14-4517b091385b@linaro.org
# 
#   Acked-by: Linus Walleij
#   Acked-by: Andi Shyti
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   727265eeaf8e858dfd0d7a5f3a4195e00905bfb5
#    drivers/i2c/busses/i2c-nomadik.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:20 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:18 BST 2024)
# 
#   ARM: 9366/1: coresight: tpiu: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-13-4517b091385b@linaro.org
# 
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   57c7aa7ef2d7cce9c4d59dc10c162d371e78b9f7
#    drivers/hwtracing/coresight/coresight-tpiu.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:17 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:17 BST 2024)
# 
#   ARM: 9365/1: coresight: tmc: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-10-4517b091385b@linaro.org
# 
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   a257144055b40cd0e756bb29dbf8eaed9c4b303b
#    drivers/hwtracing/coresight/coresight-tmc-core.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:14 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:16 BST 2024)
# 
#   ARM: 9364/1: coresight: replicator: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-7-4517b091385b@linaro.org
# 
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   90b5ec20e7204511f70f52eaa3dc7a6e5a6c2bbf
#    drivers/hwtracing/coresight/coresight-replicator.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:11 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:15 BST 2024)
# 
#   ARM: 9363/1: coresight: etm3x: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-4-4517b091385b@linaro.org
# 
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   152a7a4c4dc10270b7e95fe38527d66bd9dd2887
#    drivers/hwtracing/coresight/coresight-etm3x-core.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:10 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:14 BST 2024)
# 
#   ARM: 9362/1: coresight: catu: drop owner assignment
# 
#   Amba bus core already sets owner, so driver does not need to.
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-3-4517b091385b@linaro.org
# 
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   45745c84a7615c436a1a16d8643959a9c2bd72c9
#    drivers/hwtracing/coresight/coresight-catu.c | 1 -
#    1 file changed, 1 deletion(-)
# 
# Author:    Krzysztof Kozlowski (Tue  2 Apr 10:51:08 BST 2024)
# Committer: Russell King (Oracle) (Thu 18 Apr 12:09:14 BST 2024)
# 
#   ARM: 9361/1: amba: store owner from modules with amba_driver_register()
# 
#   Modules registering driver with amba_driver_register() often forget to
#   set .owner field.  The field is used by some of other kernel parts for
#   reference counting (try_module_get()), so it is expected that drivers
#   will set it.
# 
#   Solve the problem by moving this task away from the drivers to the core
#   amba bus code, just like we did for platform_driver in
#   commit 9447057eaff8 ("platform_device: use a macro instead of
#   platform_driver_register").
# 
#   Link: https://lore.kernel.org/r/20240326-module-owner-amba-v1-1-4517b091385b@linaro.org
# 
#   Reviewed-by: Andi Shyti
#   Acked-by: Suzuki K Poulose
#   Signed-off-by: Krzysztof Kozlowski
#   Signed-off-by: Russell King (Oracle)
# 
#   5677b17c33246fb69ecc250d493c635500b78980
#    drivers/amba/bus.c       | 11 +++++++----
#    include/linux/amba/bus.h | 11 +++++++++--
#    2 files changed, 16 insertions(+), 6 deletions(-)
# 
diff --git a/arch/arm/Kconfig b/arch/arm/Kconfig
index b14aed3a17ab..749d6e3788b4 100644
--- a/arch/arm/Kconfig
+++ b/arch/arm/Kconfig
@@ -35,6 +35,7 @@ config ARM
 	select ARCH_OPTIONAL_KERNEL_RWX if ARCH_HAS_STRICT_KERNEL_RWX
 	select ARCH_OPTIONAL_KERNEL_RWX_DEFAULT if CPU_V7
 	select ARCH_SUPPORTS_ATOMIC_RMW
+	select ARCH_SUPPORTS_CFI_CLANG
 	select ARCH_SUPPORTS_HUGETLBFS if ARM_LPAE
 	select ARCH_SUPPORTS_PER_VMA_LOCK
 	select ARCH_USE_BUILTIN_BSWAP
@@ -1233,9 +1234,9 @@ config HIGHPTE
 	  consumed by page tables.  Setting this option will allow
 	  user-space 2nd level page tables to reside in high memory.
 
-config CPU_SW_DOMAIN_PAN
-	bool "Enable use of CPU domains to implement privileged no-access"
-	depends on MMU && !ARM_LPAE
+config ARM_PAN
+	bool "Enable privileged no-access"
+	depends on MMU
 	default y
 	help
 	  Increase kernel security by ensuring that normal kernel accesses
@@ -1244,10 +1245,26 @@ config CPU_SW_DOMAIN_PAN
 	  by ensuring that magic values (such as LIST_POISON) will always
 	  fault when dereferenced.
 
+	  The implementation uses CPU domains when !CONFIG_ARM_LPAE and
+	  disabling of TTBR0 page table walks with CONFIG_ARM_LPAE.
+
+config CPU_SW_DOMAIN_PAN
+	def_bool y
+	depends on ARM_PAN && !ARM_LPAE
+	help
+	  Enable use of CPU domains to implement privileged no-access.
+
 	  CPUs with low-vector mappings use a best-efforts implementation.
 	  Their lower 1MB needs to remain accessible for the vectors, but
 	  the remainder of userspace will become appropriately inaccessible.
 
+config CPU_TTBR0_PAN
+	def_bool y
+	depends on ARM_PAN && ARM_LPAE
+	help
+	  Enable privileged no-access by disabling TTBR0 page table walks when
+	  running in kernel mode.
+
 config HW_PERF_EVENTS
 	def_bool y
 	depends on ARM_PMU
